# 7.5.0

The 7.5 release includes a solid batch of new features and fixes.  Among the improvements, you'll find more control over label decluttering, improved WebGL semi-transparent tile rendering, more consistency hit detecting transparent items, improvements with WebGL vector rendering, fixes for raster source loading, and more.

No special changes should be required when upgrading from previous 7.x releases.  See the [upgrade notes](./upgrade-notes.md) for a few minor changes in behavior.

#### List of all changes

See below for a complete list of features and fixes.

 * New flushDeclutterItems() map method to control declutter stack (by @ahocevar in https://github.com/openlayers/openlayers/pull/14971)
 * Render VectorLayer when ReplayGroup is empty but render listener exists (by @M393 in https://github.com/openlayers/openlayers/pull/14984)
 * Improve the description of the Coordinate type (by @Isti115 in https://github.com/openlayers/openlayers/pull/14994)
 * Use none to avoid hit detection of text fills (by @tschaub in https://github.com/openlayers/openlayers/pull/14992)
 * Reorganise old no fill / transparent fill tests (by @mike-000 in https://github.com/openlayers/openlayers/pull/14982)
 * Migrate to @rollup/plugin-terser (by @bjornharrtell in https://github.com/openlayers/openlayers/pull/14985)
 * WebGLTile: Properly render semi-transparent tiles (by @puckipedia in https://github.com/openlayers/openlayers/pull/14983)
 * Hit detect transparent fill and backgroundFill in Text styles (by @mike-000 in https://github.com/openlayers/openlayers/pull/14943)
 * Hit detect images even if zero opacity (by @mike-000 in https://github.com/openlayers/openlayers/pull/14939)
 * Fix test for keyboard zoom on a Mac (by @fjellfly in https://github.com/openlayers/openlayers/pull/14977)
 * Apply dashed line hit detection to all geometry types (by @mike-000 in https://github.com/openlayers/openlayers/pull/14938)
 * npx update-browserslist-db@latest (by @ahocevar in https://github.com/openlayers/openlayers/pull/14975)
 * fix #14968 (by @tanhh326 in https://github.com/openlayers/openlayers/pull/14972)
 * Don't overwrite browser zoom shortcuts (by @fjellfly in https://github.com/openlayers/openlayers/pull/14946)
 * Add upgrade note about start/end textAlign fix (by @ahocevar in https://github.com/openlayers/openlayers/pull/14970)
 * Fix textAlign start/end for placement: line (by @ahocevar in https://github.com/openlayers/openlayers/pull/14932)
 * Cannot create polygon from empty extent (by @mike-000 in https://github.com/openlayers/openlayers/pull/14962)
 * Use Terrarium tiles in Shaded Relief examples (by @mike-000 in https://github.com/openlayers/openlayers/pull/14957)
 * fix Style RenderFunction type (by @tanhh326 in https://github.com/openlayers/openlayers/pull/14956)
 * Update TileJSON source url (by @mike-000 in https://github.com/openlayers/openlayers/pull/14937)
 * Slightly enhance documentation for circle radius (by @openlayers in https://github.com/openlayers/openlayers/pull/14951)
 * More WebGL TileHelper cleanup (by @ahocevar in https://github.com/openlayers/openlayers/pull/14935)
 * Better types for more timeouts (by @mike-000 in https://github.com/openlayers/openlayers/pull/14934)
 * WebGL helper improvements (by @ahocevar in https://github.com/openlayers/openlayers/pull/14929)
 * Use new headless option for Puppeteer (by @ahocevar in https://github.com/openlayers/openlayers/pull/14928)
 * Add typedef, use underscore for private methods (by @mike-000 in https://github.com/openlayers/openlayers/pull/14925)
 * Fix infinite tile rendering loop and incomplete images in Raster source (by @ahocevar in https://github.com/openlayers/openlayers/pull/14922)
 * Remove .nvmrc (by @ahocevar in https://github.com/openlayers/openlayers/pull/14917)
 * Remove reference to ES5 (by @mike-000 in https://github.com/openlayers/openlayers/pull/14907)
 * Draw features style example (by @ahocevar in https://github.com/openlayers/openlayers/pull/14920)
 * Fix cluster source handling of points with null geometry (by @roemhildtg in https://github.com/openlayers/openlayers/pull/14915)
 * Avoid line dash flicker in Measure examples (by @mike-000 in https://github.com/openlayers/openlayers/pull/14918)
 * Use `touch-action: none;` for elements in viewport (by @mike-000 in https://github.com/openlayers/openlayers/pull/14906)
 * return last snapTo feature (by @fmg-lydonchandra in https://github.com/openlayers/openlayers/pull/14676)
 * Fix dynamic background color (by @kikuchan in https://github.com/openlayers/openlayers/pull/14895)
 * Remove marked warning (by @ahocevar in https://github.com/openlayers/openlayers/pull/14878)
 * Update concepts.md (by @barnoma-soz in https://github.com/openlayers/openlayers/pull/14882)
 * Fix VectorImageLayer opacity (by @MrLynx93 in https://github.com/openlayers/openlayers/pull/14867)
 * Another attempt to avoid missing tiles with the Raster source (by @ahocevar in https://github.com/openlayers/openlayers/pull/14856)
 * Avoid missing tiles for Raster source using Tile layers or sources (by @ahocevar in https://github.com/openlayers/openlayers/pull/14853)
 * WebGL / Support styles with only fill, stroke or symbol, better defaults (by @jahow in https://github.com/openlayers/openlayers/pull/14840)
 * Use MapTiler Coordinates API to find proj4 transforms without `+nadgrids` for `fromEPSGCode()` (by @mike-000 in https://github.com/openlayers/openlayers/pull/14692)
 * Remove pointer events polyfill from examples (by @ahocevar in https://github.com/openlayers/openlayers/pull/14816)
 * Optionally show or hide Bing 'placeholder' tiles (by @Shane98c in https://github.com/openlayers/openlayers/pull/14832)
 * Expressions / add `geometry-type` operator, fix exponential `interpolate` (by @jahow in https://github.com/openlayers/openlayers/pull/14837)
 * Test image with less text for lower font engine sensitivity (by @ahocevar in https://github.com/openlayers/openlayers/pull/14828)
 * Add support for 'in' and 'sqrt' operators in expressions (by @jahow in https://github.com/openlayers/openlayers/pull/14803)
 * Rework webgl points hit detection (by @gberaudo in https://github.com/openlayers/openlayers/pull/14806)
 * send 'loadend' event on layer image load failure (by @Tobias43 in https://github.com/openlayers/openlayers/pull/14810)
 * Add option-based support for options.target in ZoomSlider (by @Pierstoval in https://github.com/openlayers/openlayers/pull/14807)
 * Update reference image for changed type system on CI (by @ahocevar in https://github.com/openlayers/openlayers/pull/14805)
 * Update sponsors (by @ahocevar in https://github.com/openlayers/openlayers/pull/14789)
 * Fix ufos example with type hint (by @MoonE in https://github.com/openlayers/openlayers/pull/14791)
 * Miscellaneous rich text documentation fixes (by @mike-000 in https://github.com/openlayers/openlayers/pull/14790)
 * Get a pixel perfect match WMS image (by @sbrunner in https://github.com/openlayers/openlayers/pull/14719)
 * Updates for the 7.4.0 release (by @openlayers in https://github.com/openlayers/openlayers/pull/14787)


<details>
  <summary>Dependency Updates</summary>

 * Bump puppeteer from 20.9.0 to 21.0.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14980)
 * Bump marked from 5.1.2 to 7.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14981)
 * Bump handlebars from 4.7.7 to 4.7.8 (by @openlayers in https://github.com/openlayers/openlayers/pull/14979)
 * Bump marked from 5.1.1 to 5.1.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14960)
 * Bump eslint from 8.45.0 to 8.46.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14959)
 * Bump @metalsmith/in-place from 4.6.0 to 5.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14940)
 * Bump puppeteer from 20.8.2 to 20.9.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14942)
 * Bump webpack from 5.88.1 to 5.88.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14941)
 * Bump eslint from 8.44.0 to 8.45.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14903)
 * Bump @octokit/rest from 19.0.13 to 20.0.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14905)
 * Bump metalsmith from 2.6.0 to 2.6.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14904)
 * Bump puppeteer from 20.8.0 to 20.8.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14902)
 * Bump @rollup/plugin-commonjs from 25.0.2 to 25.0.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/14901)
 * Bump globby from 13.2.1 to 13.2.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14890)
 * Bump puppeteer from 20.7.4 to 20.8.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14889)
 * Bump marked from 5.1.0 to 5.1.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14888)
 * Bump semver from 7.5.3 to 7.5.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/14887)
 * Bump webpack from 5.88.0 to 5.88.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14874)
 * Bump globby from 13.2.0 to 13.2.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14876)
 * Bump eslint from 8.43.0 to 8.44.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14875)
 * Bump typescript from 5.1.3 to 5.1.6 (by @openlayers in https://github.com/openlayers/openlayers/pull/14873)
 * Bump puppeteer from 20.7.3 to 20.7.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/14872)
 * Bump sinon from 15.1.2 to 15.2.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14863)
 * Bump webpack from 5.87.0 to 5.88.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14862)
 * Bump @rollup/plugin-commonjs from 25.0.1 to 25.0.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14860)
 * Bump puppeteer from 20.7.2 to 20.7.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/14861)
 * Bump semver from 7.5.2 to 7.5.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/14864)
 * Bump webpack from 5.86.0 to 5.87.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14848)
 * Bump globby from 13.1.4 to 13.2.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14847)
 * Bump puppeteer from 20.7.1 to 20.7.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14846)
 * Bump @octokit/rest from 19.0.11 to 19.0.13 (by @openlayers in https://github.com/openlayers/openlayers/pull/14845)
 * Bump sinon from 15.1.0 to 15.1.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14844)
 * Bump semver from 7.5.1 to 7.5.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/14843)
 * Bump eslint from 8.42.0 to 8.43.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14842)
 * Bump puppeteer from 20.5.0 to 20.7.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14829)
 * Bump webpack-cli from 5.1.3 to 5.1.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/14824)
 * Bump @rollup/plugin-commonjs from 25.0.0 to 25.0.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14821)
 * Bump marked from 5.0.4 to 5.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14819)
 * Bump webpack-dev-server from 4.15.0 to 4.15.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14822)
 * Bump webpack from 5.85.1 to 5.86.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14823)
 * Bump @metalsmith/markdown from 1.9.2 to 1.10.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14818)
 * Bump ol-mapbox-style from 10.5.0 to 10.6.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14794)
 * Bump webpack from 5.84.1 to 5.85.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/14804)
 * Bump metalsmith from 2.5.1 to 2.6.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14801)
 * Bump @rollup/plugin-node-resolve from 15.0.2 to 15.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14798)
 * Bump eslint from 8.41.0 to 8.42.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14797)
 * Bump typescript from 5.0.4 to 5.1.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/14795)
 * Bump webpack-cli from 5.1.1 to 5.1.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/14802)
 * Bump puppeteer from 20.4.0 to 20.5.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/14799)
 * Bump marked from 5.0.3 to 5.0.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/14796)


</details>
