# 8.2.0

The 8.2 release includes fixes for a few bugs in the 8.1 release and a couple new enhancements, including new WebGL features and support for `ol/render/Feature` for vector layers.  Nothing special is required when upgrading from 8.1. Only TypeScript users might have to make minor changes, because some types have been made more strict.

#### List of all changes

See below for a complete list of features and fixes.

 * Segment snap (by @ahocevar in https://github.com/openlayers/openlayers/pull/15312)
 * Export TileGrid and WMTSTileGrid from ol/tilegrid (by @mike-000 in https://github.com/openlayers/openlayers/pull/15309)
 * WebGL / Add support for patterns in polygons and lines (by @jahow in https://github.com/openlayers/openlayers/pull/15279)
 * Use ol.css from example build, logos and site css from the website (by @ahocevar in https://github.com/openlayers/openlayers/pull/15280)
 * Use local theme instead of root website theme for versioned examples (by @ahocevar in https://github.com/openlayers/openlayers/pull/15277)
 * Make `apiKey` and `retina` properties optional (by @ahocevar in https://github.com/openlayers/openlayers/pull/15278)
 * Fix `fromUserResolution` and `toUserResolution` for `useGeographic()` (by @kikuchan in https://github.com/openlayers/openlayers/pull/15214)
 * fix(Map): use same size calculation in `updateSize` and `updateViewportSize_` (by @simonseyock in https://github.com/openlayers/openlayers/pull/15269)
 * Add a GLSL compiler for expressions (by @jahow in https://github.com/openlayers/openlayers/pull/15121)
 * Implement ID operator for style expression (by @behoney in https://github.com/openlayers/openlayers/pull/15271)
 * Moved geometry type check for hit detection in Modify interaction (by @adhaca in https://github.com/openlayers/openlayers/pull/15270)
 * Fix ShaderBuilder for with symbolRotateWithView (by @kikuchan in https://github.com/openlayers/openlayers/pull/15229)
 * Better types for geometries (by @MoonE in https://github.com/openlayers/openlayers/pull/15196)
 * Add support for user projections to WebGLPoints layer (by @kikuchan in https://github.com/openlayers/openlayers/pull/15234)
 * #14554: WFS 2.0.0 writeTransaction UPDATE missing ValueReference - fix (by @arekgotfryd in https://github.com/openlayers/openlayers/pull/15197)
 * Style Expressions Concat Function
 (by @MannyKSoSo in https://github.com/openlayers/openlayers/pull/15250)
 * Fix TileImage's transition is incorrect when re-projection (by @yujinpan in https://github.com/openlayers/openlayers/pull/15239)
 * Allow `touch-action: pan-x pan-y;` on viewport (by @mike-000 in https://github.com/openlayers/openlayers/pull/15208)
 * More strict type checks (by @MoonE in https://github.com/openlayers/openlayers/pull/15189)
 * Cluster example duplicate if condition removed (by @ShanteshSindgi in https://github.com/openlayers/openlayers/pull/15188)
 * Fix some more strict type check problems (by @MoonE in https://github.com/openlayers/openlayers/pull/15184)
 * Strict type checks for select files (by @MoonE in https://github.com/openlayers/openlayers/pull/15181)
 * Make rules documentation example syntax valid (by @mike-000 in https://github.com/openlayers/openlayers/pull/15179)
 * Do not use stitchContext for ReprojImage (by @mike-000 in https://github.com/openlayers/openlayers/pull/15168)
 * Interpolation support for Canvas styles (by @tschaub in https://github.com/openlayers/openlayers/pull/15141)
 * Create new loader if view projection changes (by @mike-000 in https://github.com/openlayers/openlayers/pull/15165)
 * Add properties to WebGLTileLayer options type (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15164)
 * Throw an error when building flat styles that result in an empty style (by @tschaub in https://github.com/openlayers/openlayers/pull/15142)
 * docs: update docs for draw interaction style (by @simonseyock in https://github.com/openlayers/openlayers/pull/15163)
 * WebGL / fix hit detection for vector layer on certain systems (by @jahow in https://github.com/openlayers/openlayers/pull/15159)
 * Properly hit detect circles after updating size (by @tschaub in https://github.com/openlayers/openlayers/pull/15143)
 * Parse more variety of color strings (by @tschaub in https://github.com/openlayers/openlayers/pull/15137)
 * WebGL / Implement tile masking for vector tiles (by @jahow in https://github.com/openlayers/openlayers/pull/15127)
 * Fix the type for VectorTile features (by @ahocevar in https://github.com/openlayers/openlayers/pull/15131)
 * Add hit detection support to WebGL vector layer (by @gberaudo in https://github.com/openlayers/openlayers/pull/15120)
 * New expression operators, allow chain of args validator (by @tschaub in https://github.com/openlayers/openlayers/pull/15130)
 * Named color parsing (by @tschaub in https://github.com/openlayers/openlayers/pull/15128)
 * Make RenderFeature work for untiled vector data (by @ahocevar in https://github.com/openlayers/openlayers/pull/15123)
 * #11229: add more description for z parameter of getTileCoordForCoordA… (by @arekgotfryd in https://github.com/openlayers/openlayers/pull/15124)
 * Parse JSON only once (by @ahocevar in https://github.com/openlayers/openlayers/pull/15122)
 * Make tooltip / hint  on hover example (by @arekgotfryd in https://github.com/openlayers/openlayers/pull/15117)
 * Support updating and tracking extra params in the link interaction (by @tschaub in https://github.com/openlayers/openlayers/pull/15116)
 * Add support for user projections to WebGL rendering (by @tschaub in https://github.com/openlayers/openlayers/pull/15118)
 * setStyle should pass paletteTextures in WebGLTile Layer and Renderer (by @malaretv in https://github.com/openlayers/openlayers/pull/15101)
 * Allow render features to be transformed (by @tschaub in https://github.com/openlayers/openlayers/pull/15115)
 * WebGL / only check polygons winding order for RenderFeature (by @jahow in https://github.com/openlayers/openlayers/pull/15114)
 * Make inflateEnds work regardless of the y coordinate orientation (by @ahocevar in https://github.com/openlayers/openlayers/pull/15113)
 * Add getFeatureInfoUrl and getLegendUrl functions to ol/wms (by @ahocevar in https://github.com/openlayers/openlayers/pull/15102)
 * Return loaded image when decode fails (by @ahocevar in https://github.com/openlayers/openlayers/pull/15103)
 * Do not attempt to decode image if `src` is not set (by @mike-000 in https://github.com/openlayers/openlayers/pull/15094)
 * Updates for the 8.1.0 release (by @openlayers in https://github.com/openlayers/openlayers/pull/15091)


<details>
  <summary>Dependency Updates</summary>

 * Bump puppeteer from 21.4.1 to 21.5.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15305)
 * Bump rollup from 4.1.5 to 4.3.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15304)
 * Bump eslint from 8.52.0 to 8.53.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15303)
 * Bump sinon from 17.0.0 to 17.0.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15302)
 * Bump ol-mapbox-style from 12.0.0 to 12.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15301)
 * Bump marked from 9.1.3 to 9.1.5 (by @openlayers in https://github.com/openlayers/openlayers/pull/15300)
 * Bump proj4 from 2.9.1 to 2.9.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15283)
 * Bump rollup from 4.1.4 to 4.1.5 (by @openlayers in https://github.com/openlayers/openlayers/pull/15284)
 * Bump marked from 9.1.2 to 9.1.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15285)
 * Bump @types/geojson from 7946.0.11 to 7946.0.12 (by @openlayers in https://github.com/openlayers/openlayers/pull/15286)
 * Bump puppeteer from 21.4.0 to 21.4.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15287)
 * Bump actions/setup-node from 3 to 4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15282)
 * Bump geotiff from 2.0.7 to 2.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15288)
 * Bump rollup and rollup-plugin-external (by @openlayers in https://github.com/openlayers/openlayers/pull/15276)
 * Bump eslint from 8.50.0 to 8.52.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15267)
 * Bump @types/offscreencanvas from 2019.7.1 to 2019.7.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15266)
 * Bump loglevelnext from 5.0.6 to 6.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15260)
 * Bump @types/topojson-specification from 1.0.3 to 1.0.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15265)
 * Bump @types/arcgis-rest-api from 10.4.6 to 10.4.7 (by @openlayers in https://github.com/openlayers/openlayers/pull/15262)
 * Bump sinon from 16.1.0 to 17.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15264)
 * Bump @types/proj4 from 2.5.3 to 2.5.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15263)
 * Bump @types/pbf from 3.0.3 to 3.0.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15261)
 * Bump puppeteer from 21.3.6 to 21.4.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15259)
 * Bump @rollup/plugin-node-resolve from 15.2.1 to 15.2.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15223)
 * Bump @rollup/plugin-terser from 0.4.3 to 0.4.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15224)
 * Bump sinon from 16.0.0 to 16.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15222)
 * Bump @rollup/plugin-commonjs from 25.0.4 to 25.0.7 (by @openlayers in https://github.com/openlayers/openlayers/pull/15240)
 * Bump marked from 9.0.3 to 9.1.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15243)
 * Bump webpack from 5.88.2 to 5.89.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15242)
 * Bump proj4 from 2.9.0 to 2.9.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15244)
 * Bump @octokit/rest from 20.0.1 to 20.0.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15200)
 * Bump puppeteer from 21.3.4 to 21.3.6 (by @openlayers in https://github.com/openlayers/openlayers/pull/15199)
 * Bump rollup from 3.29.3 to 3.29.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15198)
 * Bump @types/arcgis-rest-api from 10.4.5 to 10.4.6 (by @openlayers in https://github.com/openlayers/openlayers/pull/15173)
 * Bump @types/geojson from 7946.0.10 to 7946.0.11 (by @openlayers in https://github.com/openlayers/openlayers/pull/15174)
 * Bump @types/pbf from 3.0.2 to 3.0.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15175)
 * Bump @types/proj4 from 2.5.2 to 2.5.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15177)
 * Bump rollup from 3.29.2 to 3.29.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15178)
 * Bump eslint from 8.49.0 to 8.50.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15172)
 * Bump marked from 9.0.2 to 9.0.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15176)
 * Bump puppeteer from 21.2.1 to 21.3.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15171)
 * Bump color-rgba from 2.4.0 to 3.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15149)
 * Bump puppeteer from 21.1.1 to 21.2.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15153)
 * Bump ol-mapbox-style from 11.0.3 to 12.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15150)
 * Bump marked from 9.0.0 to 9.0.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15151)
 * Bump rollup from 3.29.1 to 3.29.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15152)
 * Bump yargs from 17.7.1 to 17.7.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15154)
 * Bump @types/topojson-specification from 1.0.2 to 1.0.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15155)
 * Bump sinon from 15.2.0 to 16.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15148)
 * Bump rollup from 3.28.1 to 3.29.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15112)
 * Bump marked from 8.0.0 to 9.0.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15110)
 * Bump actions/checkout from 3 to 4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15108)
 * Bump eslint from 8.48.0 to 8.49.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15111)


</details>
