# 9.2.0

The 9.2 release fixes a number of rendering issues and introduces a few new features.  OGC tile sources now support collections selection.  Snap events are now more consistent (see below).  Type annotations continue to improve, and documentation and examples got a number of updates.

#### The `snap` event's feature property is now never `null`

Previously, listeners for the `Snap` interaction's `snap` event received `null` as value for the `feature` property when snapped to a segment. Now, the value of the `feature` property is always set to the snapped feature.

To distinguish between a vertex and a segment snap, look at the `snap` event's `segment` property. It will set to `null` on a vertex snap, and to the snapped segment on a segment snap.

#### List of all changes

See below for a complete list of features and fixes.

 * Align getStyle() behavior and documentation (by @ahocevar in https://github.com/openlayers/openlayers/pull/15826)
 * Calculate reprojection tile ranges for each world (by @mike-000 in https://github.com/openlayers/openlayers/pull/15825)
 * Fix removal of render features from vector source (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15827)
 * fix: handle errors in response parsing in xhr loader (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15808)
 * Hit detect symbols with declutterMode: 'none' (by @ahocevar in https://github.com/openlayers/openlayers/pull/15812)
 * refactor: remove unneeded '/' for URL construction (by @jansule in https://github.com/openlayers/openlayers/pull/15809)
 * Stop using deprecated search API from EPSG.io (by @petrsloup in https://github.com/openlayers/openlayers/pull/15806)
 * feat: add collections option to OGCVectorTile source (by @jansule in https://github.com/openlayers/openlayers/pull/15792)
 * fix: webgl style regression - force ambiguous match input type to an accepted type (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15802)
 * Add feature type generic to feature loader types (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15780)
 * Accept render features source in WebGLPointsLayer (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15779)
 * Fix WebGL VectorLayer wrapX renderer (by @sakitam-gis in https://github.com/openlayers/openlayers/pull/15785)
 * Fix deferred rendering of layer extents, multiple worlds and non-1 opacity (by @ahocevar in https://github.com/openlayers/openlayers/pull/15796)
 * Improve performance of deferred rendering (by @ahocevar in https://github.com/openlayers/openlayers/pull/15789)
 * Delete palette texture before creating a new context (by @tschaub in https://github.com/openlayers/openlayers/pull/15787)
 * Add feature type to vector source signature (by @sebakerckhof in https://github.com/openlayers/openlayers/pull/15774)
 * Better generics for vector and vectortile layers (by @ahocevar in https://github.com/openlayers/openlayers/pull/15767)
 * Show how to combine a layer with a render function and a standard layer (by @ahocevar in https://github.com/openlayers/openlayers/pull/15762)
 * Rebuild executors when declutter state changes (by @ahocevar in https://github.com/openlayers/openlayers/pull/15768)
 * Remove unused layer property (by @M393 in https://github.com/openlayers/openlayers/pull/15765)
 * fix: Group.d.ts type errors #15756 (by @sakitam-gis in https://github.com/openlayers/openlayers/pull/15757)
 * Use outdoor instead of streets style for site and mapbox-style example (by @ahocevar in https://github.com/openlayers/openlayers/pull/15738)
 * Fix getFeatures(pixel) regression (by @ahocevar in https://github.com/openlayers/openlayers/pull/15734)
 * Add Snap Data: feature (by @CarolineDelerue in https://github.com/openlayers/openlayers/pull/15730)
 * Reuse container preparation code (by @ahocevar in https://github.com/openlayers/openlayers/pull/15727)
 * Fix:issues#15716, compute the actual height of the text style background (by @Frank-Chan in https://github.com/openlayers/openlayers/pull/15717)
 * Fix offscreen-canvas example and make code more web worker friendly (by @ahocevar in https://github.com/openlayers/openlayers/pull/15720)
 * update MapTiler maps in examples (by @bolollo in https://github.com/openlayers/openlayers/pull/15725)
 * Fix VectorImageLayer declutter description (by @janruo in https://github.com/openlayers/openlayers/pull/15724)
 * Fix VectorImageLayer options types (by @janruo in https://github.com/openlayers/openlayers/pull/15713)
 * Document the string and number operators (by @tschaub in https://github.com/openlayers/openlayers/pull/15700)
 * Update satellite tiles url (by @mike-000 in https://github.com/openlayers/openlayers/pull/15669)
 * Tile render order (by @ahocevar in https://github.com/openlayers/openlayers/pull/15685)
 * Update terrain-rgb URL Fixes #15686 (by @bolollo in https://github.com/openlayers/openlayers/pull/15687)
 * Support for newer IGC format versions (by @ahocevar in https://github.com/openlayers/openlayers/pull/15696)
 * Update MapTiler streets url (by @mike-000 in https://github.com/openlayers/openlayers/pull/15688)
 * Render vector layers to same css rotated canvas as other layers (by @ahocevar in https://github.com/openlayers/openlayers/pull/15683)
 * Only declutter when necessary (by @ahocevar in https://github.com/openlayers/openlayers/pull/15682)
 * Add missing api tag on removeFeatures (by @ger-benjamin in https://github.com/openlayers/openlayers/pull/15679)
 * Clear RenderBox on DragBox Deactivation (by @behoney in https://github.com/openlayers/openlayers/pull/15671)


<details>
  <summary>Dependency Updates</summary>

 * Bump puppeteer from 22.8.1 to 22.8.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15828)
 * Bump puppeteer from 22.8.0 to 22.8.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15821)
 * Bump semver from 7.6.0 to 7.6.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15822)
 * Bump puppeteer from 22.7.1 to 22.8.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15800)
 * Bump jsdoc from 4.0.2 to 4.0.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15799)
 * Bump @octokit/rest from 20.1.0 to 20.1.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15798)
 * Bump rollup from 4.16.1 to 4.17.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15788)
 * Bump rollup from 4.16.1 to 4.17.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15782)
 * Bump puppeteer from 22.6.5 to 22.7.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15783)
 * Bump ol-mapbox-style from 12.3.1 to 12.3.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15781)
 * Bump rollup from 4.14.3 to 4.16.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15761)
 * Bump marked from 12.0.1 to 12.0.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15760)
 * Bump ol-stac from 1.0.0-beta.9 to 1.0.0-beta.10 (by @openlayers in https://github.com/openlayers/openlayers/pull/15743)
 * Bump puppeteer from 22.6.3 to 22.6.5 (by @openlayers in https://github.com/openlayers/openlayers/pull/15742)
 * Bump typescript from 5.4.4 to 5.4.5 (by @openlayers in https://github.com/openlayers/openlayers/pull/15741)
 * Bump rollup from 4.14.1 to 4.14.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15740)
 * Bump rollup from 4.13.2 to 4.14.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15712)
 * Bump puppeteer from 22.6.1 to 22.6.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15707)
 * Bump webpack-dev-middleware from 7.2.0 to 7.2.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15711)
 * Bump @octokit/rest from 20.0.2 to 20.1.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15709)
 * Bump typescript from 5.4.3 to 5.4.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15708)
 * Bump rollup-plugin-external-globals from 0.9.2 to 0.10.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15706)
 * Bump puppeteer from 22.6.0 to 22.6.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15695)
 * Bump webpack-dev-middleware from 7.1.1 to 7.2.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15694)
 * Bump rollup from 4.13.0 to 4.13.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15693)
 * Bump mocha from 10.3.0 to 10.4.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15692)
 * Bump ol-mapbox-style from 12.2.1 to 12.3.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15691)
 * Bump proj4 from 2.10.0 to 2.11.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15663)
 * Bump express from 4.18.3 to 4.19.2 (by @openlayers in https://github.com/openlayers/openlayers/pull/15684)
 * Bump typescript from 5.4.2 to 5.4.3 (by @openlayers in https://github.com/openlayers/openlayers/pull/15661)
 * Bump express from 4.18.3 to 4.19.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15662)
 * Bump webpack-dev-server from 5.0.3 to 5.0.4 (by @openlayers in https://github.com/openlayers/openlayers/pull/15664)
 * Bump puppeteer from 22.5.0 to 22.6.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15665)
 * Bump webpack-dev-middleware from 7.1.0 to 7.1.1 (by @openlayers in https://github.com/openlayers/openlayers/pull/15666)
 * Bump webpack from 5.90.3 to 5.91.0 (by @openlayers in https://github.com/openlayers/openlayers/pull/15667)


</details>
